#ifndef TREE_ELEMENT_H
#define TREE_ELEMENT_H

// Copyright (c) The University of Cincinnati.  
// All rights reserved.

// UC MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF 
// THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
// TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
// PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  UC SHALL NOT BE LIABLE
// FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING,
// RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
// DERIVATIVES.

// By using or copying this Software, Licensee agrees to abide by the
// intellectual property laws, and all other applicable laws of the
// U.S., and the terms of this license.

// Authors: Malolan Chetlur             mal@ececs.uc.edu
//          Jorgen Dahl                 dahlj@ececs.uc.edu
//          Dale E. Martin              dmartin@cliftonlabs.com
//          Radharamanan Radhakrishnan  ramanan@ececs.uc.edu
//          Dhananjai Madhava Rao       dmadhava@ececs.uc.edu
//          Philip A. Wilsey            phil.wilsey@uc.edu


#include <iostream>

class Event;
class TreeElement;

class TreeElement {
private:

  TreeElement *leftTree;
  TreeElement *rightTree;
  TreeElement *parentElement;
  const Event *infoNode;

public:

  TreeElement(const Event *bEvent ):
    leftTree(NULL),
    rightTree(NULL),
    parentElement(NULL),
    infoNode(bEvent) {}

  ~TreeElement() {}

  inline TreeElement *getLeftElement() {
    return leftTree;
  }

  inline TreeElement *getRightElement() {
    return rightTree;
  }

  inline TreeElement *getParentElement() {
    return parentElement;
  }

  inline void setLeftElement(TreeElement *lElement) {
    leftTree = lElement;
  }

  inline void setRightElement(TreeElement *rElement) {
    rightTree = rElement;
  }

  inline void setParentElement(TreeElement *pElement) {
    parentElement = pElement;
  }

  inline const Event *getEvent() {
    return infoNode;
  }

};

#endif
